<template>
  <q-page class="flex-center">
    <q-table
      :rows-per-page-options="[15, 25, 50]"
      :data="data"
      :columns="columns"
      separator="cell"
      :filter="filter"
      :pagination.sync="pagination"
      row-key="id"
    >
      <template slot="top" slot-scope="props">
        <q-btn
          push
          rounded
          color="primary"
          icon="add"
          @click="add()"
          v-show="permissions.includes('add_group')"
          >Add Group
        </q-btn>
        <div class="col" />
        <div>
          <q-toolbar class="bg-primary text-back rounded-borders">
            <q-input
              dark
              dense
              standout
              v-model="filter"
              input-class="text-right"
              class="q-ml-md"
            >
              <template v-slot:append>
                <q-icon v-if="filter === ''" name="search" />
                <q-icon
                  v-else
                  name="clear"
                  class="cursor-pointer"
                  @click="filter = ''"
                />
              </template>
            </q-input>
          </q-toolbar>
        </div>
      </template>
      <q-tr slot="body" slot-scope="props" :props="props">
        <q-td
          key="No"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
          >{{ props.row.No }}</q-td
        >
        <q-td
          key="name"
          :props="props"
          :style="{ width: '500px', whiteSpace: 'normal' }"
          >{{ props.row.name }}</q-td
        >
        <q-td
          key="code"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          >{{ props.row.code }}</q-td
        >
        <q-td
          key="image"
          :props="props"
          :style="{ width: '200px', whiteSpace: 'normal' }"
        >
          <template>
            <img :src="ConvertImage(props.row.image)" class="image" />
          </template>
        </q-td>
        <q-td
          key="is_display"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
        >
          <q-toggle
            key="is_display"
            v-model="props.row.is_display"
            :false-value="0"
            :true-value="1"
            @input="ChangeDisplay(props.row)"
            :disable="!permissions.includes('change_group')"
          />
        </q-td>
        <q-td
          key="status"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
        >
          <q-toggle
            v-model="props.row.status"
            :false-value="0"
            :true-value="1"
            @input="ChangeStatus(props.row)"
            :disable="!permissions.includes('change_group')"
          />
        </q-td>
        <q-td
          key="action"
          :props="props"
          :style="{ width: '5%', whiteSpace: 'normal' }"
        >
          <div class="row items-center justify-left no-wrap">
            <q-btn
              size="sm"
              round
              rounded
              color="secondary"
              icon="edit"
              @click="load(props.row)"
              class="q-mr-xs"
              v-show="permissions.includes('change_group')"
            />
            <q-btn
              size="sm"
              round
              rounded
              color="negative"
              icon="delete"
              @click="remove(props.row)"
              class="q-mr-xs"
              v-show="permissions.includes('delete_group')"
            />
          </div>
        </q-td>
      </q-tr>
    </q-table>
    <!-- add -->
    <q-dialog
      v-model="modal_add"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form"
            ref="form"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Name" prop="name">
              <el-input v-model="form.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Code" prop="code">
              <el-input v-model="form.code" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Image" prop="image">
              <input
                type="file"
                id="file"
                ref="file"
                v-on:change="uploadImage"
              />
            </el-form-item>
            <el-form-item>
              <img v-bind:src="`data:image/png;base64,${form.image}`" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-section>
          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :data="group_provider"
            :columns="columns_provider"
            separator="cell"
            :filter="filter_provider"
            :pagination.sync="pagination_provider"
            row-key="id"
          >
            <template slot="top" slot-scope="props">
              <q-btn
                push
                rounded
                color="primary"
                icon="add"
                @click="addProvider()"
                >Add Provider</q-btn
              >
            </template>
            <q-tr slot="body" slot-scope="props" :props="props">
              <q-td
                key="No"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
                >{{ props.row.No }}</q-td
              >
              <q-td
                key="provider"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
                >{{ props.row.provider_name }}</q-td
              >
              <q-td
                key="action"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <div class="row items-center justify-between no-wrap">
                  <q-btn
                    size="sm"
                    round
                    rounded
                    color="negative"
                    icon="delete"
                    @click="remove_provider(props.row)"
                    class="q-mr-xs"
                  />
                </div>
              </q-td>
            </q-tr>
          </q-table>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn
            push
            rounded
            color="primary"
            @click="insert()"
            v-show="permissions.includes('add_group')"
            >Submit</q-btn
          >
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- add provider -->
    <q-dialog
      v-model="modal_add_provider"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_provider"
            ref="form_provider"
            :rules="rules_provider"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Provider" prop="provider">
              <q-select
                filled
                label="Select Provider"
                v-model="form_provider.provider"
                :options="provider_options"
              />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded color="primary" @click="insert_provider()"
            >Submit</q-btn
          >
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- end -->

    <!-- update -->
    <q-dialog
      v-model="modal_edit"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_edit"
            ref="form_edit"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Name" prop="name">
              <el-input v-model="form_edit.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Code" prop="code">
              <el-input v-model="form_edit.code" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Image" prop="image">
              <input
                type="file"
                id="file"
                ref="file"
                v-on:change="uploadImageEdit"
              />
            </el-form-item>
            <el-form-item>
              <img :src="ConvertImage(form_edit.image)" class="image" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-section>
          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :data="group_provider"
            :columns="columns_provider"
            separator="cell"
            :filter="filter_provider"
            :pagination.sync="pagination_provider"
            row-key="id"
          >
            <template slot="top" slot-scope="props">
              <q-btn
                push
                rounded
                color="primary"
                icon="add"
                @click="addProvider()"
                >Add Provider</q-btn
              >
            </template>
            <q-tr slot="body" slot-scope="props" :props="props">
              <q-td
                key="No"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
                >{{ props.row.No }}</q-td
              >
              <q-td
                key="provider"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
                >{{ props.row.provider_name }}</q-td
              >
              <q-td
                key="is_lobby"
                :props="props"
                :style="{ width: '5%', whiteSpace: 'normal' }"
              >
                <q-toggle v-model="props.row.is_lobby" />
              </q-td>
              <q-td
                key="reorder"
                :props="props"
                :style="{ width: '5%', whiteSpace: 'normal' }"
              >
                <div class="row items-center justify-between no-wrap">
                  <q-btn
                    size="sm"
                    round
                    rounded
                    icon="arrow_upward"
                    @click="reorder('UP', props.row)"
                    class="q-mr-xs"
                  />
                  <q-btn
                    size="sm"
                    round
                    rounded
                    icon="arrow_downward"
                    @click="reorder('DOWN', props.row)"
                    class="q-mr-xs"
                  />
                </div>
              </q-td>
              <q-td
                key="action"
                :props="props"
                :style="{ width: '20px', whiteSpace: 'normal' }"
              >
                <div class="row items-center justify-between no-wrap">
                  <q-btn
                    size="sm"
                    round
                    rounded
                    color="negative"
                    icon="delete"
                    @click="remove_provider(props.row)"
                    class="q-mr-xs"
                  />
                </div>
              </q-td>
            </q-tr>
          </q-table>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn
            push
            rounded
            color="primary"
            @click="Update()"
            v-show="permissions.includes('change_group')"
            >Submit</q-btn
          >
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
export default {
  name: "Group",
  data() {
    return {
      data: [],
      search: "",
      columns: [
        {
          name: "No",
          label: "No",
          field: "No",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "code",
          label: "Code",
          field: "code",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "image",
          label: "Image",
          field: "image",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "is_display",
          label: "Display",
          field: "is_display",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status",
          label: "Status",
          field: "status",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      filter: "",
      separator: "horizontal",
      pagination: {
        sortBy: null,
        descending: false,
        page: 1,
        rowsPerPage: 10
      },
      modal_edit: false,
      modal_add: false,
      form: { name: "", image: null, code: "" },
      form_edit: {},
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      options: [
        { value: 1, label: "Enable" },
        { value: 0, label: "Disable" }
      ],
      rules: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        code: [
          { required: true, message: "Please input code", trigger: "blur" }
        ]
      },
      permissions:
        this.$q.sessionStorage.getItem("permissions")["group"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["group"]
          : [],
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      group_provider: [],
      columns_provider: [
        {
          name: "No",
          label: "No",
          field: "No",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "provider",
          label: "Provider",
          field: "provider",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "is_lobby",
          label: "Lobby",
          field: "is_lobby",
          width: "10px",
          require: true,
          align: "center",
          stortable: true
        },
        {
          name: "reorder",
          label: "order",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      pagination_provider: {
        sortBy: null,
        descending: false,
        page: 1,
        rowsPerPage: 10
      },
      form_provider: {
        provider: ""
      },
      provider_options: [],
      rules_provider: {
        provider: [
          {
            required: true,
            message: "Please Select Provider",
            trigger: "change"
          }
        ]
      },
      filter_provider: "",
      modal_add_provider: false
    };
  },

  async created() {
    await this.getdata();
    await this.get_provider();
  },

  methods: {
    reorder(flag, row) {
      const currentIndex = this.group_provider.findIndex(x => x.id == row.id);
      if (flag.toUpperCase() == "UP" && currentIndex > 0) {
        this.group_provider[currentIndex - 1].order = currentIndex;
        this.group_provider[currentIndex].order = currentIndex - 1;
      } else if (
        flag.toUpperCase() == "DOWN" &&
        currentIndex < this.group_provider.length - 1
      ) {
        this.group_provider[currentIndex].order = currentIndex + 1;
        this.group_provider[currentIndex + 1].order = currentIndex;
      }
      this.group_provider = _.chain(this.group_provider)
        .orderBy(x => x.order)
        .map((x, index) => {
          x.No = index + 1;
          return x;
        })
        .value();
    },
    async getdata(pageNumber) {
      try {
        this.data = await this.$services.group.read({});
        this.$services.updateindex(this.data);
      } catch (e) {
        this.$services.error(e.response, this.$router);
      }
    },

    add() {
      this.modal_add = true;
      this.form = { name: "", image: null, code: "" };
    },

    async insert() {
      let ctx = this;
      this.$refs.form.validate(valid => {
        if (valid) {
          this.form.detail = this.group_provider;
          this.$services.group
            .add(this.form)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_add = false;
              ctx.$services.success("Save Group Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        }
      });
    },

    async load(row) {
      this.form_edit = row;
      this.modal_edit = true;
      this.get_provider_group(row.id);
    },

    async get_provider_group(id) {
      let data = await this.$services.group.group_provider(id);
      this.group_provider = _.orderBy(data, x => x.order);
      this.$services.updateindex(this.group_provider);
    },

    async Update() {
      let ctx = this;
      this.$refs.form_edit.validate(valid => {
        if (valid) {
          this.form_edit.detail = this.group_provider;
          this.$services.group
            .update(this.form_edit, this.form_edit.id)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_edit = false;
              ctx.$services.success("Update Group Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        }
      });
    },

    async remove(row) {
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want to Group ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          ctx.$services.group
            .remove(row.id)
            .then(function(e) {
              ctx.getdata();
              ctx.$services.success("Delete Group " + row.name + " Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          // console.log('>>>> Cancel')
        });
    },

    ChangeStatus(row) {
      const prev = row.status == 0 ? 1 : 0;
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Group ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.group
            .update(row, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Group Success");
            })
            .catch(function(e) {
              row.status = prev;
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          row.status = prev;
          // console.log('>>>> Cancel')
        });
    },
    ChangeDisplay(row) {
      const prev = row.is_display == 0 ? 1 : 0;
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Display to Group ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.group
            .update(row, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Group Success");
            })
            .catch(function(e) {
              row.status = prev;
              ctx.$services.error(e.response, ctx.$router);
            });
        })
        .onCancel(() => {
          row.is_display = prev;
          // console.log('>>>> Cancel')
        });
    },
    uploadImage(e) {
      const image = e.target.files[0];
      const reader = new FileReader();
      reader.readAsDataURL(image);
      reader.onload = e => {
        this.form.image = e.target.result.split(",")[1];
      };
    },

    uploadImageEdit(e) {
      const image = e.target.files[0];
      const reader = new FileReader();
      reader.readAsDataURL(image);
      reader.onload = e => {
        this.form_edit.image = e.target.result.split(",")[1];
      };
    },

    ConvertImage(image) {
      if (image != "") {
        if (/(http(s?)):\/\//i.test(image)) {
          return image;
        } else {
          return `data:image/png;base64,${image}`;
        }
      } else {
        return "";
      }
    },

    async get_provider() {
      let ctx = this;
      this.$services.provider
        .read({ status: 1 })
        .then(function(data) {
          data.forEach(row => {
            ctx.provider_options.push({ value: row.id, label: row.name });
          });
        })
        .catch(function(e) {
          ctx.$services.error(e.response, ctx.$router);
        });
    },

    addProvider() {
      this.modal_add_provider = true;
      this.form_provider.provider = "";
    },

    async insert_provider() {
      this.$refs.form_provider.validate(valid => {
        if (valid) {
          this.group_provider.push({
            provider: this.form_provider.provider.value,
            provider_name: this.form_provider.provider.label,
            is_lobby: 1,
            status: 1,
            order: this.group_provider.length
          });
          this.$services.updateindex(this.group_provider);
          this.modal_add_provider = false;
        }
      });
    },

    async remove_provider(row) {
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want to Provider ${row.provider_name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          // console.log('row:', row)
          // this.group_provider.splice(row.No)
          this.group_provider.splice(this.group_provider.indexOf(row.No), 1);
          this.$services.success("Delete Provider " + row.name + " Success");
          // console.log(this.group_provider)
          // ctx.$services.group.remove(row.id)
          // .then(function(e) {
          //   ctx.get_provider_group(row.group)
          //   ctx.$services.success('Delete Provider '+ row.name +' Success')
          // })
          // .catch(function(e){
          //   ctx.$services.error(e.response, ctx.$router)
          // })
        })
        .onCancel(() => {
          // console.log('>>>> Cancel')
        });
    }
  }
};
</script>

<style lang="stylus"></style>
<style type="text/css">
img {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 100%;
}

.image {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 50%;
}
</style>
